## cairo-dock 3.2.1

=== CMakeLists.txt ===
########### requirements ###############

cmake_minimum_required (VERSION 2.6)
find_package (PkgConfig)
include (CheckLibraryExists)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include ("${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/GNUInstallDirs.cmake")

########### project ###############

project ("cairo-dock")
set (VERSION "3.2.1")

add_definitions (-std=c99 -Wall -Wextra) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
if (NOT ${CMAKE_BUILD_TYPE})
	add_definitions (-O3)
endif()
add_definitions (-DGL_GLEXT_PROTOTYPES="1")
add_definitions (-DCAIRO_DOCK_DEFAULT_ICON_NAME="default-icon.svg")
add_definitions (-DCAIRO_DOCK_ICON="cairo-dock.svg")
add_definitions (-DCAIRO_DOCK_LOGO="cairo-dock-logo.png")
add_definitions (-DCAIRO_DOCK_DATA_DIR="cairo-dock")
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")


###########     Misc     ###############
macro (enable_if_not_defined MODULE1)
	if (NOT DEFINED MODULE1) # true if not defined
		set (${MODULE1} TRUE)
	endif ()
endmacro (enable_if_not_defined)


##########     Config    ###############

enable_if_not_defined (force-icon-in-menus)
if (force-icon-in-menus)  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
else()
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
endif()

############ sources tarball ############

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
set (CPACK_SOURCE_IGNORE_FILES 
	"/build/;/.bzr/;bzrignore$;/config.h$;/gldi-module-config.h$;/gldi-config.h$;/doc/;/misc/;~$;/TODO$;${CPACK_SOURCE_IGNORE_FILES}")
include (CPack)

add_custom_target( dist
	COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(dist-bzr
	COMMAND bzr export ${CMAKE_PROJECT_NAME}-${VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

########### global variables ###############

if( WIN32 )
	message(FATAL_ERROR "Cairo-Dock requires an air-conditioned room. Please close Windows!")
endif( WIN32 )

set (PACKAGE ${CMAKE_PROJECT_NAME})
set (GETTEXT_PACKAGE ${PACKAGE})

set (prefix ${CMAKE_INSTALL_PREFIX})  # /usr/local
set (exec_prefix ${prefix})
set (datadir "${prefix}/${CMAKE_INSTALL_DATAROOTDIR}")  # (...)/share
set (pkgdatadir "${datadir}/${CMAKE_PROJECT_NAME}")  # (...)/cairo-dock
set (mandir "${prefix}/${CMAKE_INSTALL_MANDIR}")  # (...)/man

if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND (force-lib64 OR "${FORCE_LIB64}" STREQUAL "yes"))  # 64bits and force install in lib64
	set (libdir "${prefix}/lib64")
elseif (NOT "${LIB_SUFFIX}" STREQUAL "")
	set (libdir "${prefix}/lib${LIB_SUFFIX}")  # (...)/libXX ## some distro use ${LIB_SUFFIX}
else()
	set (libdir "${prefix}/${CMAKE_INSTALL_LIBDIR}")  # (...)/lib or (...)/lib64 or custom ## GNU Install dir
endif()

set (includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")  # (...)/include
set (bindir "${prefix}/${CMAKE_INSTALL_BINDIR}")  # (...)/bin

set (pluginsdir "${libdir}/cairo-dock")
set (pluginsdatadir "${pkgdatadir}/plug-ins")
if (NOT DEFINED install-pc-path)
	set (install-pc-path "${libdir}/pkgconfig")  # it can be different (for example ${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig on BSD)
endif ()

########### dependencies ###############

set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu libcurl")  # for the .pc and to have details
STRING (REGEX REPLACE " " ";" packages_required_semicolon ${packages_required})  # replace blank space by semicolon => to have more details if a package is missing
pkg_check_modules ("PACKAGE" REQUIRED "${packages_required_semicolon}")

set (with_xentend no)
enable_if_not_defined (enable-x11-ext-support) # enabled by default
if (enable-x11-ext-support)
	set (xextend_required "xtst xcomposite xrandr")  # for the .pc
	STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
	pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")
	
	if (XEXTEND_FOUND)
		set (HAVE_XEXTEND 1)
		set (with_xentend yes)
		
		pkg_check_modules ("XINERAMA" "xinerama")  # check for Xinerama separately, since is now replaced by Xrandr >= 1.3
		if (XINERAMA_FOUND)
			set (HAVE_XINERAMA 1)
		endif()
	else()
		set (xextend_required)
	endif()
endif()

if (NOT force-gtk2)  # by default, we use GTK+3 except if we force the use of GTK+2
	set (gtk_required "gtk+-3.0")  # for the .pc
	pkg_check_modules ("GTK" "${gtk_required}")  # the check is not set as 'required' because we can use GTK+2 if GTK+3 isn't available
endif()

if (NOT GTK_FOUND)
	set (gtk_required "gtk+-2.0")  # for the .pc
	pkg_check_modules ("GTK" REQUIRED "${gtk_required}")  # the check is requiered this time because we need GTK anyway.
endif()

STRING (REGEX REPLACE "\\..*" "" GTK_MAJOR "${GTK_VERSION}")

add_definitions (-DGTK_DISABLE_DEPRECATED="1")
# add_definitions (-DG_DISABLE_DEPRECATED="1")

# We use crypt(3) which may be in libc, or in libcrypt (eg FreeBSD)
check_library_exists (crypt encrypt "" HAVE_LIBCRYPT)
if (HAVE_LIBCRYPT)
	set (LIBCRYPT_LIBS "-lcrypt")
endif()

check_symbol_exists (LC_MESSAGES "locale.h" HAVE_LC_MESSAGES)
check_include_files ("math.h" HAVE_MATH_H)
check_library_exists (m sin "" HAVE_LIBM)
if (NOT HAVE_LIBM OR NOT HAVE_MATH_H)
	message(FATAL_ERROR "Cairo-Dock requires math.h")
endif()

check_include_files ("dlfcn.h" HAVE_DLFCN_H)
check_library_exists (dl dlopen "" HAVE_LIBDL)
if (HAVE_LIBDL)  # dlopen might be in libc directly as in FreeBSD
	set (LIBDL_LIBRARIES "dl")
endif()
if (NOT HAVE_DLFCN_H)
	message(FATAL_ERROR "Cairo-Dock requires dlfcn.h")
endif()

check_library_exists (intl libintl_gettext "" HAVE_LIBINTL)
if (HAVE_LIBINTL)  # on BSD, we have to link to libintl to be able to use gettext.
	set (LIBINTL_LIBRARIES "intl")
endif()


########### variables defined at compil time ###############

set (CAIRO_DOCK_SHARE_DATA_DIR ${pkgdatadir})
set (CAIRO_DOCK_SHARE_THEMES_DIR ${pkgdatadir}/themes)
#set (CAIRO_DOCK_MODULES_DIR ${libdir}/cairo-dock)
set (CAIRO_DOCK_LOCALE_DIR "${prefix}/${CMAKE_INSTALL_LOCALEDIR}")
set (CAIRO_DOCK_THEMES_DIR "themes")  # folder name where themes are saved locally, relatively to the root folder of Cairo-Dock.
set (CAIRO_DOCK_DISTANT_THEMES_DIR "themes3.2")  # folder name where themes are on the server, relatively to the root folder of the server files.
set (CAIRO_DOCK_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})

set (GLDI_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
set (GLDI_SHARE_DATA_DIR ${pkgdatadir})
set (GLDI_MODULES_DIR ${pluginsdir})
set (GLDI_BIN_DIR ${bindir})

########### next steps ###############

add_subdirectory (src)
add_subdirectory (data)
add_subdirectory (po)

############# HELP #################
# this is actually a plug-in for cairo-dock, not for gldi
# it uses some functions of cairo-dock (they are binded dynamically), that's why it can't go with other plug-ins
set (GETTEXT_HELP ${GETTEXT_PACKAGE})
set (VERSION_HELP "0.9.994")
set (PACKAGE_HELP "cd-Help")
set (helpdatadir "${pluginsdatadir}/Help")
set (dock_version "${VERSION}")
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Help/data/Help.conf.in ${CMAKE_CURRENT_BINARY_DIR}/Help/data/Help.conf)
add_subdirectory (Help)

########### file generation ###############

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-module-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-module-config.h)  # separated from gldi-config.h because it's architecture-dependant (it contains $libdir), so it can't be installed in /usr/include without causing a conflict between 32 and 64 bits packages.
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.pc.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)

########### install files ###############

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc DESTINATION ${install-pc-path})

################# Summary #################

MESSAGE (STATUS)
MESSAGE (STATUS "Cairo-Dock ${VERSION} will be compiled with the following options:")
if (XEXTEND_FOUND)
	MESSAGE (STATUS " * Use X Extensions: Yes")
else()
	MESSAGE (STATUS " * Use X Extensions: No")
endif()
if (HAVE_LIBCRYPT)
	MESSAGE (STATUS " * Crypt passwords : Yes")
else()
	MESSAGE (STATUS " * Crypt passwords : No")
endif()
MESSAGE (STATUS " * GTK version       : ${GTK_MAJOR} (${GTK_VERSION})")
MESSAGE (STATUS " * Installation in   : ${prefix}")
MESSAGE (STATUS " * Lib directory     : ${libdir}")
MESSAGE (STATUS " * With X11 ext.     : ${with_xentend} (${xextend_required})")
MESSAGE (STATUS " * Themes directory  : ${CAIRO_DOCK_DISTANT_THEMES_DIR}")
if (enable-desktop-manager)
	set (with_cd_session yes)
else()
	set (cd-with_cd_session no)
endif()
MESSAGE (STATUS " * Cairo-dock session: ${with_cd_session}")
MESSAGE (STATUS)

=== src/CMakeLists.txt ===

add_subdirectory (icon-factory)
add_subdirectory (gldit)
add_subdirectory (implementations)

SET(cairo_dock_SRCS
	cairo-dock.c
	cairo-dock-menu.c 					cairo-dock-menu.h 
	cairo-dock-user-interaction.c 		cairo-dock-user-interaction.h 
	cairo-dock-gui-advanced.c 			cairo-dock-gui-advanced.h
	cairo-dock-gui-simple.c 			cairo-dock-gui-simple.h
	cairo-dock-gui-backend.c 			cairo-dock-gui-backend.h
	cairo-dock-gui-commons.c 			cairo-dock-gui-commons.h
	cairo-dock-widget.c 				cairo-dock-widget.h
	cairo-dock-widget-themes.c 			cairo-dock-widget-themes.h
	cairo-dock-widget-items.c 			cairo-dock-widget-items.h
	cairo-dock-widget-config.c 			cairo-dock-widget-config.h
	cairo-dock-widget-plugins.c 		cairo-dock-widget-plugins.h
	cairo-dock-widget-module.c			cairo-dock-widget-module.h
	cairo-dock-widget-config-group.c 	cairo-dock-widget-config-group.h
	cairo-dock-widget-shortkeys.c		cairo-dock-widget-shortkeys.h
)

########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit)

# Add executable that is built from the source files.
add_executable (${PROJECT_NAME}
	${cairo_dock_SRCS} )

# Link the executable to the librairies.
target_link_libraries (${PROJECT_NAME}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	gldi
	icon-factory
	${LIBINTL_LIBRARIES})

# install the program once it is built.
install(
	TARGETS ${PACKAGE}
	DESTINATION bin)

=== Help/src/CMakeLists.txt ===

########### sources ###############

SET(MODULE_SRCS
	applet-struct.h
	applet-init.c 			applet-init.h
	applet-config.c 			applet-config.h
	applet-notifications.c 		applet-notifications.h
	applet-tips-dialog.c 		applet-tips-dialog.h
	applet-composite.c 		applet-composite.h
)

add_library(${PACKAGE_HELP} SHARED ${MODULE_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${helpdatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="icon.svg")
add_definitions (-DMY_APPLET_CONF_FILE="Help.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Help")
add_definitions (-DMY_APPLET_VERSION="${VERSION_HELP}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_HELP}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.svg")
### uncomment the following line to allow multi-instance applet.
#add_definitions (-DCD_APPLET_MULTI_INSTANCE="1")
### uncomment the following line to allow extended OpenGL drawing.
#add_definitions (-DGL_GLEXT_PROTOTYPES="1")

include_directories (
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

link_directories (
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS})

target_link_libraries (${PACKAGE_HELP}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES})

########### install files ###############

install(TARGETS ${PACKAGE_HELP} DESTINATION ${pluginsdir})

=== src/gldit/CMakeLists.txt ===

SET(core_lib_SRCS
	cairo-dock-struct.h
	cairo-dock-global-variables.h 
	cairo-dock-core.c 					cairo-dock-core.h
	cairo-dock-manager.c 				cairo-dock-manager.h
	cairo-dock-object.c 				cairo-dock-object.h
	# icons
	cairo-dock-icon-manager.c 			cairo-dock-icon-manager.h
	cairo-dock-icon-factory.c 			cairo-dock-icon-factory.h
	cairo-dock-icon-facility.c 			cairo-dock-icon-facility.h
	cairo-dock-indicator-manager.c 		cairo-dock-indicator-manager.h
	cairo-dock-applications-manager.c 	cairo-dock-applications-manager.h 
	cairo-dock-application-facility.c 	cairo-dock-application-facility.h
	cairo-dock-launcher-manager.c 		cairo-dock-launcher-manager.h
	cairo-dock-applet-manager.c 		cairo-dock-applet-manager.h
	cairo-dock-applet-facility.c 		cairo-dock-applet-facility.h
	cairo-dock-separator-manager.c 		cairo-dock-separator-manager.h
	cairo-dock-module-factory.c 		cairo-dock-module-factory.h
	cairo-dock-module-manager.c 		cairo-dock-module-manager.h
	# containers
	cairo-dock-container.c 				cairo-dock-container.h
	cairo-dock-desklet-manager.c 		cairo-dock-desklet-manager.h
	cairo-dock-desklet-factory.c 		cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.c 		cairo-dock-dialog-factory.h
	cairo-dock-dialog-manager.c 		cairo-dock-dialog-manager.h
	cairo-dock-flying-container.c 		cairo-dock-flying-container.h
	cairo-dock-dock-manager.c 			cairo-dock-dock-manager.h
	cairo-dock-dock-factory.c 			cairo-dock-dock-factory.h
	cairo-dock-dock-facility.c 			cairo-dock-dock-facility.h
	cairo-dock-callbacks.c 				cairo-dock-callbacks.h 
	cairo-dock-animations.c 			cairo-dock-animations.h
	cairo-dock-notifications.c 			cairo-dock-notifications.h
	cairo-dock-backends-manager.c 		cairo-dock-backends-manager.h
	cairo-dock-data-renderer.c 			cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.c 		cairo-dock-data-renderer-manager.h
	cairo-dock-file-manager.c 			cairo-dock-file-manager.h
	cairo-dock-themes-manager.c 		cairo-dock-themes-manager.h
	cairo-dock-class-manager.c 			cairo-dock-class-manager.h
	cairo-dock-X-manager.c 				cairo-dock-X-manager.h
	cairo-dock-image-buffer.c			cairo-dock-image-buffer.h 
	cairo-dock-opengl.c 				cairo-dock-opengl.h
	cairo-dock-opengl-path.c 			cairo-dock-opengl-path.h
	cairo-dock-opengl-font.c 			cairo-dock-opengl-font.h
	cairo-dock-surface-factory.c 		cairo-dock-surface-factory.h
	cairo-dock-draw.c 					cairo-dock-draw.h 
	cairo-dock-draw-opengl.c 			cairo-dock-draw-opengl.h
	# utilities
	cairo-dock-log.c 					cairo-dock-log.h
	cairo-dock-gui-manager.c 			cairo-dock-gui-manager.h
	cairo-dock-gui-factory.c 			cairo-dock-gui-factory.h
	eggaccelerators.c 					eggaccelerators.h
	cairo-dock-keybinder.c 				cairo-dock-keybinder.h
	cairo-dock-dbus.c 					cairo-dock-dbus.h 
	cairo-dock-X-utilities.c 			cairo-dock-X-utilities.h
	cairo-dock-keyfile-utilities.c 		cairo-dock-keyfile-utilities.h
	cairo-dock-packages.c 				cairo-dock-packages.h
	cairo-dock-particle-system.c 		cairo-dock-particle-system.h
	cairo-dock-overlay.c 				cairo-dock-overlay.h
	cairo-dock-task.c 					cairo-dock-task.h
	cairo-dock-config.c 				cairo-dock-config.h 
	texture-gradation.h
	texture-blur.h
)


########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${XEXTEND_INCLUDE_DIRS}
	${XINERAMA_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${XEXTEND_LIBRARY_DIRS}
	${XINERAMA_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Define the library
add_library ("gldi" SHARED ${core_lib_SRCS})
STRING (REGEX REPLACE "\\..*" "" SOVERSION "${VERSION}")
set_target_properties ("gldi" PROPERTIES
	# create *nix style library versions + symbolic links
	VERSION ${VERSION}
	SOVERSION ${SOVERSION}
	# allow creating static and shared libs without conflicts
	#CLEAN_DIRECT_OUTPUT 1
	# avoid conflicts between library and binary target names
	#OUTPUT_NAME ${PROJECT_NAME}
)

# Link the result to the librairies.
target_link_libraries("gldi"
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	${XEXTEND_LIBRARIES}
	${XINERAMA_LIBRARIES}
	${LIBCRYPT_LIBS}
	icon-factory
	implementations
	${LIBDL_LIBRARIES})


configure_file (${CMAKE_CURRENT_SOURCE_DIR}/gldi.pc.in ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc)
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc DESTINATION ${install-pc-path})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${VERSION} DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${SOVERSION} DESTINATION ${libdir})

########### install files ###############

install(FILES cairo-dock.h DESTINATION ${includedir}/cairo-dock)
install(FILES
	cairo-dock-struct.h 			cairo-dock-global-variables.h
	gldi-config.h  # gldi-module-config.h doesn't need to be installed
	cairo-dock-core.h			cairo-dock-manager.h
	cairo-dock-object.h
	cairo-dock-icon-factory.h		cairo-dock-icon-manager.h
	cairo-dock-icon-facility.h
	cairo-dock-applications-manager.h 	cairo-dock-launcher-manager.h
	cairo-dock-separator-manager.h 		cairo-dock-applet-manager.h
	cairo-dock-backends-manager.h		cairo-dock-notifications.h
	
	cairo-dock-packages.h
	cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.h
	cairo-dock-dock-manager.h		
	cairo-dock-desklet-manager.h
	cairo-dock-dialog-manager.h
	cairo-dock-indicator-manager.h
	cairo-dock-themes-manager.h
	cairo-dock-gui-manager.h
	cairo-dock-file-manager.h
	cairo-dock-X-manager.h
	cairo-dock-class-manager.h
	cairo-dock-opengl.h
	cairo-dock-image-buffer.h
	cairo-dock-config.h
	cairo-dock-module-factory.h
	cairo-dock-module-manager.h
	cairo-dock-container.h
	cairo-dock-dock-factory.h			cairo-dock-callbacks.h
	cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.h
	cairo-dock-flying-container.h
	
	cairo-dock-applet-multi-instance.h 	cairo-dock-applet-single-instance.h
	cairo-dock-applet-canvas.h			cairo-dock-applet-facility.h
	
	cairo-dock-draw.h					cairo-dock-draw-opengl.h
	cairo-dock-opengl-path.h 			cairo-dock-opengl-font.h 
	cairo-dock-particle-system.h		cairo-dock-overlay.h
	cairo-dock-X-utilities.h			cairo-dock-dbus.h
	cairo-dock-keyfile-utilities.h		cairo-dock-surface-factory.h
	cairo-dock-log.h					cairo-dock-keybinder.h
	cairo-dock-application-facility.h	cairo-dock-dock-facility.h
	cairo-dock-task.h
	cairo-dock-animations.h
	cairo-dock-gui-factory.h
	
	DESTINATION ${includedir}/cairo-dock/gldit)

if (disable-gtk-grip)
	add_definitions (-DENABLE_GTK_GRIP=1)
endif()

=== src/implementations/CMakeLists.txt ===

SET(impl_SRCS
	cairo-dock-gauge.c                   cairo-dock-gauge.h
	cairo-dock-graph.c                   cairo-dock-graph.h
	cairo-dock-progressbar.c             cairo-dock-progressbar.h
	cairo-dock-hiding-effect.c           cairo-dock-hiding-effect.h
	cairo-dock-icon-container.c          cairo-dock-icon-container.h
	cairo-dock-default-view.c            cairo-dock-default-view.h
	cairo-dock-compiz-integration.c      cairo-dock-compiz-integration.h
	cairo-dock-kwin-integration.c        cairo-dock-kwin-integration.h
	cairo-dock-gnome-shell-integration.c cairo-dock-gnome-shell-integration.h
)

add_library(implementations STATIC ${impl_SRCS})
add_definitions (-fPIC)
add_definitions (-DSHARE_DATA_DIR="${pkgdatadir}")

link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS})

include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

########### install files ###############

install (FILES
	cairo-dock-gauge.h
	cairo-dock-graph.h
	cairo-dock-progressbar.h
	DESTINATION ${includedir}/cairo-dock/implementations)  # thoses are needed to expose the attributes of the data-renderers to the plug-ins.

=== data/themes/default-theme-panel/plug-ins/Clipper/CMakeLists.txt ===
install (FILES Clipper.conf DESTINATION ${pkgdatadir}/themes/Default-Panel/plug-ins/Clipper )

=== debian/changelog ===
cairo-dock (3.2.1-0ubuntu1) raring; urgency=low

  * New upstream release. (bug-fix version) LP: #1168839
  * Detailed Upstream ChangeLog:
    - Dialogues:
      - Fixed a small bug with the default icon
      - Force taking the focus when the dialogue has an user widget, since
        some WM prevent focus steal LP: #531152
    - Gnome-Shell: the dash was hidden all the time
    - GUI:
      - Docks list: only list main docks and subdocks and not launchers and
        applications with subdocks (when there are windows with the same
        class and if these icons are regrouped into a subdock)
      - Menu and GUI: Move to another dock: if it s a container: Do not add
        subdocks that are contained in this container (to avoid loop:
        subdock1->subdock2->subdock1)
      - Simple: Plugins: Help applet was not listed
      - Simple: Config: force displaying the config widget (the config panel
        was empty with some older versions of GTK)
    - Help applet:
      - This applet didn t have any preview icon file
    - Icon:
      - Label: If we don t want to show label, keep info about the font: it
        can be used by other applets (e.g. Clock)
      - Windows thumbnails: fixed a small bug that made the thumbnail
        unavailable the first time the window is minimized
    - Init & Themes: deactivate the option Show Windows Thumbnail in the
      current theme.
      - This option can provoke annoying bugs with other applications the
        desktop (e.g. Gedit or Nautilus displayed corrupted icons when using
        a smooth scroll)
      - It seems this bug is due to the video drivers and it s fixed with
        the latest stable version of these drivers (but which is not
        available with most distributions)
      - Note: It s still possible to re-enable this option from the config
        panel
    - Taskbar: Fixed a possible crash in a convoluted scenario (if there are
      a few untitled windows with the same empty class)
    - X11:
      - Fixed a crash when using Xinerama with multi-monitors
    - Translations: Imported translations files from Launchpad
  * debian/control:
    - Bumped Cairo-Dock Plug-Ins versions

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Sun, 14 Apr 2013 11:58:46 +0200

=== debian/control ===
Source: cairo-dock
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthieu Baerts (matttbe) <matttbe@ubuntu.com>, Julien Lavergne <julien.lavergne@gmail.com>, Fabrice Rey <fabounet@glx-dock.org>
Build-Depends: cdbs,
               cmake,
               debhelper (>= 8.1.3),
               libcairo2-dev,
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libgl1-mesa-dev | libgl-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libxcomposite-dev,
               libxrandr-dev,
               libxml2-dev,
               libxrender-dev,
               libxtst-dev
Standards-Version: 3.9.3
Homepage: http://www.glx-dock.org/

Package: cairo-dock
Section: graphics
Architecture: all
Conflicts: cairo-dock (<= 2.0.8.0)
Depends: cairo-dock-core (>= ${source:Version}),
         cairo-dock-plug-ins (>= 3.2.1),
         cairo-dock-plug-ins-dbus-interface-python (>= 3.2.1),
         cairo-dock-plug-ins-integration (>= 3.2.1),
         ${misc:Depends}
Description: Light and eye-candy dock to launch your programs (metapackage)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This metapackage provides the components necessary for running Cairo-Dock. It
 provides the Cairo-Dock core, a set of standard plugins and the files necessary
 to integrate Cairo-Dock with your desktop environment.

Package: cairo-dock-core
Section: graphics
Architecture: any
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0)
Depends: cairo-dock-data (>= ${source:Version}),
         libgldi3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cairo-dock,
            cairo-dock-plug-ins,
            compiz-plugins | e17 | kde-window-manager | openbox | xfwm4 | mutter
Suggests: compiz-plugins, gnome-session
Description: Light and eye-candy dock to launch your programs (core package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package is the core of Cairo-Dock project.

Package: libgldi-dev
Section: libdevel
Architecture: any
Depends: libcairo2-dev,
         libcurl4-gnutls-dev,
         libdbus-glib-1-dev,
         libgl1-mesa-dev | libgl-dev,
         libgldi3 (= ${binary:Version}),
         libglib2.0-dev,
         libglu1-mesa-dev | libglu-dev,
         libgtk-3-dev,
         libpango1.0-dev,
         librsvg2-dev,
         libxcomposite-dev,
         libxrandr-dev,
         libxml2-dev,
         libxrender-dev,
         libxtst-dev,
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: cairo-dock
Multi-Arch: same
Description: Light and eye-candy dock to launch your programs (dev package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package provides the include files and static library for cairo-dock
 functions.

Package: cairo-dock-data
Section: graphics
Architecture: all
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0)
Depends: ${misc:Depends}
Description: Light and eye-candy dock to launch your programs (common files)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package contains default icons and themes for Cairo-Dock.

Package: libgldi3
Section: graphics
Architecture: any
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0), cairo-dock-core (<< 3.0.0)
Breaks: cairo-dock-core (<< 3.0.0)
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: cairo-dock-data (>= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Light and eye-candy dock to launch your programs (lib package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package contains the library created and used by the Cairo-Dock project.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DH_ALWAYS_EXCLUDE=CVS:.bzr

DEB_CMAKE_EXTRA_FLAGS += -Denable-desktop-manager=ON \
	-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_INSTALL_CHANGELOGS_ALL := ChangeLog

get-orig-source:
	dh_testdir
	uscan --force-download --verbose --repack

## cairo-dock 3.2.99.beta1.1~20130827~bzr1613

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,10 +11,10 @@
 ########### project ###############
 
 project ("cairo-dock")
-set (VERSION "3.2.1")
-
-add_definitions (-std=c99 -Wall -Wextra) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
-if (NOT ${CMAKE_BUILD_TYPE})
+set (VERSION "3.2.99.beta1")
+
+add_definitions (-std=c99 -Wall -Wextra -Werror-implicit-function-declaration) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds)
+if (NOT DEFINED CMAKE_BUILD_TYPE)
 	add_definitions (-O3)
 endif()
 add_definitions (-DGL_GLEXT_PROTOTYPES="1")
@@ -36,7 +36,7 @@
 ##########     Config    ###############
 
 enable_if_not_defined (force-icon-in-menus)
-if (force-icon-in-menus)  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
+if (force-icon-in-menus)  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=OFF" is provided in the cmake command.
 	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
 else()
 	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
@@ -90,14 +90,30 @@
 
 ########### dependencies ###############
 
-set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu libcurl")  # for the .pc and to have details
+# check for mendatory dependencies
+set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 gl glu libcurl")  # for the .pc and to have details
 STRING (REGEX REPLACE " " ";" packages_required_semicolon ${packages_required})  # replace blank space by semicolon => to have more details if a package is missing
 pkg_check_modules ("PACKAGE" REQUIRED "${packages_required_semicolon}")
 
+set (with_x11 no)
 set (with_xentend no)
-enable_if_not_defined (enable-x11-ext-support) # enabled by default
-if (enable-x11-ext-support)
-	set (xextend_required "xtst xcomposite xrandr")  # for the .pc
+enable_if_not_defined (enable-x11-support) # enabled by default
+if (enable-x11-support)
+	# check for X11
+	set (x11_required "x11")  # for the .pc
+	pkg_check_modules ("X11" ${x11_required})
+	if (X11_FOUND)
+		set (HAVE_X11 1)
+		set (with_x11 yes)
+	else()
+		set (x11_required)
+	endif()
+	
+	# check for GLX
+	check_library_exists (GL glXMakeCurrent "" HAVE_GLX)  # HAVE_GLX remains undefined if not found, else it's "1"
+	
+	# check for X extensions
+	set (xextend_required "xtst xcomposite xrandr xrender")  # for the .pc
 	STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
 	pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")
 	
@@ -105,7 +121,7 @@
 		set (HAVE_XEXTEND 1)
 		set (with_xentend yes)
 		
-		pkg_check_modules ("XINERAMA" "xinerama")  # check for Xinerama separately, since is now replaced by Xrandr >= 1.3
+		pkg_check_modules ("XINERAMA" "xinerama")  # check for Xinerama separately, since it is now replaced by Xrandr >= 1.3
 		if (XINERAMA_FOUND)
 			set (HAVE_XINERAMA 1)
 		endif()
@@ -125,8 +141,10 @@
 endif()
 
 STRING (REGEX REPLACE "\\..*" "" GTK_MAJOR "${GTK_VERSION}")
-
-add_definitions (-DGTK_DISABLE_DEPRECATED="1")
+STRING (REGEX REPLACE "[0-9]*\\.([^ ]+)" "\\1" GTK_MINOR "${GTK_VERSION}")  # 3.8.2 => 3.8
+STRING (REGEX REPLACE "\\.[0-9]*" "" GTK_MINOR "${GTK_MINOR}") # 3.8 => 8
+
+# add_definitions (-DGTK_DISABLE_DEPRECATED="1")
 # add_definitions (-DG_DISABLE_DEPRECATED="1")
 
 # We use crypt(3) which may be in libc, or in libcrypt (eg FreeBSD)
@@ -194,36 +212,32 @@
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h)
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h)
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-module-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-module-config.h)  # separated from gldi-config.h because it's architecture-dependant (it contains $libdir), so it can't be installed in /usr/include without causing a conflict between 32 and 64 bits packages.
-configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.pc.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc)
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
-
-########### install files ###############
-
-install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc DESTINATION ${install-pc-path})
 
 ################# Summary #################
 
 MESSAGE (STATUS)
 MESSAGE (STATUS "Cairo-Dock ${VERSION} will be compiled with the following options:")
-if (XEXTEND_FOUND)
-	MESSAGE (STATUS " * Use X Extensions: Yes")
-else()
-	MESSAGE (STATUS " * Use X Extensions: No")
+MESSAGE (STATUS " * Installation in    : ${prefix}")
+MESSAGE (STATUS " * Lib directory      : ${libdir}")
+MESSAGE (STATUS " * GTK version        : ${GTK_MAJOR} (${GTK_VERSION})")
+MESSAGE (STATUS " * With X11 support   : ${with_x11}")
+MESSAGE (STATUS " * With X11 extensions: ${with_xentend} (${xextend_required})")
+if (HAVE_GLX)
+	MESSAGE (STATUS " * With GLX support   : yes")
+else()
+	MESSAGE (STATUS " * With GLX support   : no")
 endif()
 if (HAVE_LIBCRYPT)
-	MESSAGE (STATUS " * Crypt passwords : Yes")
-else()
-	MESSAGE (STATUS " * Crypt passwords : No")
-endif()
-MESSAGE (STATUS " * GTK version       : ${GTK_MAJOR} (${GTK_VERSION})")
-MESSAGE (STATUS " * Installation in   : ${prefix}")
-MESSAGE (STATUS " * Lib directory     : ${libdir}")
-MESSAGE (STATUS " * With X11 ext.     : ${with_xentend} (${xextend_required})")
-MESSAGE (STATUS " * Themes directory  : ${CAIRO_DOCK_DISTANT_THEMES_DIR}")
+	MESSAGE (STATUS " * Crypt passwords    : yes")
+else()
+	MESSAGE (STATUS " * Crypt passwords    : no")
+endif()
 if (enable-desktop-manager)
-	set (with_cd_session yes)
-else()
-	set (cd-with_cd_session no)
-endif()
-MESSAGE (STATUS " * Cairo-dock session: ${with_cd_session}")
+	set (with_cd_session "yes")
+else()
+	set (with_cd_session "no (use '-Denable-desktop-manager=ON' to enable it)")
+endif()
+MESSAGE (STATUS " * Cairo-dock session : ${with_cd_session}")
+MESSAGE (STATUS " * Themes directory   : ${CAIRO_DOCK_DISTANT_THEMES_DIR} (on the server)")
 MESSAGE (STATUS)

=== debian/changelog ===
cairo-dock (3.2.99.beta1.1~20130827~bzr1613-0ubuntu1) saucy; urgency=low

  * New upstream snapshot.
  * Short Upstream ChangeLog:
    - Added support of the StartupNotification protocol
    - A huge rewrite of the core using Objects
  * debian/rules:
    - Added DEB_BUILD_PARALLEL flag
  * debian/control:
    - Bumped plugins version
  * debian/patches/:
    - Removed cairo-dock-session_without_fallback_session: fixed by upstream

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Tue, 27 Aug 2013 16:38:10 +0200

cairo-dock (3.2.1-0ubuntu2) saucy; urgency=low

  * debian/patches/cairo-dock-session_without_fallback_session.patch:
    - Refreshed to support Gnome-Session 3.8 (bzr upstream patch)

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Sat, 22 Jun 2013 13:19:03 +0200

=== debian/control ===
--- 
+++ 
@@ -28,9 +28,9 @@
 Architecture: all
 Conflicts: cairo-dock (<= 2.0.8.0)
 Depends: cairo-dock-core (>= ${source:Version}),
-         cairo-dock-plug-ins (>= 3.2.1),
-         cairo-dock-plug-ins-dbus-interface-python (>= 3.2.1),
-         cairo-dock-plug-ins-integration (>= 3.2.1),
+         cairo-dock-plug-ins (>= 3.2.98),
+         cairo-dock-plug-ins-dbus-interface-python (>= 3.2.98),
+         cairo-dock-plug-ins-integration (>= 3.2.98),
          ${misc:Depends}
 Description: Light and eye-candy dock to launch your programs (metapackage)
  Cairo-Dock is a pretty, light and convenient interface to your desktop,

## cairo-dock 3.2.99.beta2.1~20130919~bzr1630

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 ########### project ###############
 
 project ("cairo-dock")
-set (VERSION "3.2.99.beta1")
+set (VERSION "3.2.99.beta2")
 
 add_definitions (-std=c99 -Wall -Wextra -Werror-implicit-function-declaration) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds)
 if (NOT DEFINED CMAKE_BUILD_TYPE)
@@ -47,7 +47,7 @@
 set (CPACK_SOURCE_GENERATOR "TGZ")
 set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
 set (CPACK_SOURCE_IGNORE_FILES 
-	"/build/;/.bzr/;bzrignore$;/config.h$;/gldi-module-config.h$;/gldi-config.h$;/doc/;/misc/;~$;/TODO$;${CPACK_SOURCE_IGNORE_FILES}")
+	"/build/;/.bzr/;bzrignore$;/config.h$;/gldi-module-config.h$;/gldi-config.h$;/doc/;/misc/;~$;/TODO$;.pyc$;${CPACK_SOURCE_IGNORE_FILES}")
 include (CPack)
 
 add_custom_target( dist

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
 
-add_subdirectory (icon-factory)
 add_subdirectory (gldit)
 add_subdirectory (implementations)
 
@@ -27,8 +26,7 @@
 include_directories(
 	${PACKAGE_INCLUDE_DIRS}
 	${GTK_INCLUDE_DIRS}
-	${CMAKE_SOURCE_DIR}/src/gldit
-	${CMAKE_SOURCE_DIR}/src/icon-factory)
+	${CMAKE_SOURCE_DIR}/src/gldit)
 
 # Make sure the linker can find the libraries.
 link_directories(
@@ -45,7 +43,6 @@
 	${PACKAGE_LIBRARIES}
 	${GTK_LIBRARIES}
 	gldi
-	icon-factory
 	${LIBINTL_LIBRARIES})
 
 # install the program once it is built.

=== src/gldit/CMakeLists.txt ===
--- 
+++ 
@@ -10,14 +10,17 @@
 	cairo-dock-icon-factory.c 			cairo-dock-icon-factory.h
 	cairo-dock-icon-facility.c 			cairo-dock-icon-facility.h
 	cairo-dock-indicator-manager.c 		cairo-dock-indicator-manager.h
-	cairo-dock-applications-manager.c 	cairo-dock-applications-manager.h 
+	cairo-dock-applications-manager.c 	cairo-dock-applications-manager.h
 	cairo-dock-application-facility.c 	cairo-dock-application-facility.h
 	cairo-dock-launcher-manager.c 		cairo-dock-launcher-manager.h
+	cairo-dock-stack-icon-manager.c 	cairo-dock-stack-icon-manager.h
+	cairo-dock-class-icon-manager.c 	cairo-dock-class-icon-manager.h
+	cairo-dock-user-icon-manager.c 		cairo-dock-user-icon-manager.h
 	cairo-dock-applet-manager.c 		cairo-dock-applet-manager.h
 	cairo-dock-applet-facility.c 		cairo-dock-applet-facility.h
 	cairo-dock-separator-manager.c 		cairo-dock-separator-manager.h
-	cairo-dock-module-factory.c 		cairo-dock-module-factory.h
 	cairo-dock-module-manager.c 		cairo-dock-module-manager.h
+	cairo-dock-module-instance-manager.c cairo-dock-module-instance-manager.h
 	# containers
 	cairo-dock-container.c 				cairo-dock-container.h
 	cairo-dock-desklet-manager.c 		cairo-dock-desklet-manager.h
@@ -28,16 +31,16 @@
 	cairo-dock-dock-manager.c 			cairo-dock-dock-manager.h
 	cairo-dock-dock-factory.c 			cairo-dock-dock-factory.h
 	cairo-dock-dock-facility.c 			cairo-dock-dock-facility.h
-	cairo-dock-callbacks.c 				cairo-dock-callbacks.h 
+	cairo-dock-dock-visibility.c 		cairo-dock-dock-visibility.h
 	cairo-dock-animations.c 			cairo-dock-animations.h
-	cairo-dock-notifications.c 			cairo-dock-notifications.h
 	cairo-dock-backends-manager.c 		cairo-dock-backends-manager.h
 	cairo-dock-data-renderer.c 			cairo-dock-data-renderer.h
-	cairo-dock-data-renderer-manager.c 		cairo-dock-data-renderer-manager.h
+	cairo-dock-data-renderer-manager.c 	cairo-dock-data-renderer-manager.h
 	cairo-dock-file-manager.c 			cairo-dock-file-manager.h
 	cairo-dock-themes-manager.c 		cairo-dock-themes-manager.h
 	cairo-dock-class-manager.c 			cairo-dock-class-manager.h
-	cairo-dock-X-manager.c 				cairo-dock-X-manager.h
+	cairo-dock-desktop-manager.c		cairo-dock-desktop-manager.h
+	cairo-dock-windows-manager.c		cairo-dock-windows-manager.h
 	cairo-dock-image-buffer.c			cairo-dock-image-buffer.h 
 	cairo-dock-opengl.c 				cairo-dock-opengl.h
 	cairo-dock-opengl-path.c 			cairo-dock-opengl-path.h
@@ -52,13 +55,13 @@
 	eggaccelerators.c 					eggaccelerators.h
 	cairo-dock-keybinder.c 				cairo-dock-keybinder.h
 	cairo-dock-dbus.c 					cairo-dock-dbus.h 
-	cairo-dock-X-utilities.c 			cairo-dock-X-utilities.h
 	cairo-dock-keyfile-utilities.c 		cairo-dock-keyfile-utilities.h
 	cairo-dock-packages.c 				cairo-dock-packages.h
 	cairo-dock-particle-system.c 		cairo-dock-particle-system.h
 	cairo-dock-overlay.c 				cairo-dock-overlay.h
 	cairo-dock-task.c 					cairo-dock-task.h
-	cairo-dock-config.c 				cairo-dock-config.h 
+	cairo-dock-config.c 				cairo-dock-config.h
+	cairo-dock-utils.c 					cairo-dock-utils.h
 	texture-gradation.h
 	texture-blur.h
 )
@@ -73,7 +76,6 @@
 	${XEXTEND_INCLUDE_DIRS}
 	${XINERAMA_INCLUDE_DIRS}
 	${CMAKE_SOURCE_DIR}/src/gldit
-	${CMAKE_SOURCE_DIR}/src/icon-factory
 	${CMAKE_SOURCE_DIR}/src/implementations)
 
 # Make sure the linker can find the libraries.
@@ -81,10 +83,7 @@
 	${PACKAGE_LIBRARY_DIRS}
 	${GTK_LIBRARY_DIRS}
 	${XEXTEND_LIBRARY_DIRS}
-	${XINERAMA_LIBRARY_DIRS}
-	${CMAKE_SOURCE_DIR}/src/gldit
-	${CMAKE_SOURCE_DIR}/src/icon-factory
-	${CMAKE_SOURCE_DIR}/src/implementations)
+	${XINERAMA_LIBRARY_DIRS})
 
 # Define the library
 add_library ("gldi" SHARED ${core_lib_SRCS})
@@ -106,7 +105,6 @@
 	${XEXTEND_LIBRARIES}
 	${XINERAMA_LIBRARIES}
 	${LIBCRYPT_LIBS}
-	icon-factory
 	implementations
 	${LIBDL_LIBRARIES})
 
@@ -129,7 +127,9 @@
 	cairo-dock-icon-facility.h
 	cairo-dock-applications-manager.h 	cairo-dock-launcher-manager.h
 	cairo-dock-separator-manager.h 		cairo-dock-applet-manager.h
-	cairo-dock-backends-manager.h		cairo-dock-notifications.h
+	cairo-dock-stack-icon-manager.h			cairo-dock-user-icon-manager.h
+	cairo-dock-class-icon-manager.h
+	cairo-dock-backends-manager.h
 	
 	cairo-dock-packages.h
 	cairo-dock-data-renderer.h
@@ -141,15 +141,16 @@
 	cairo-dock-themes-manager.h
 	cairo-dock-gui-manager.h
 	cairo-dock-file-manager.h
-	cairo-dock-X-manager.h
+	cairo-dock-desktop-manager.h
+	cairo-dock-windows-manager.h
 	cairo-dock-class-manager.h
 	cairo-dock-opengl.h
 	cairo-dock-image-buffer.h
 	cairo-dock-config.h
-	cairo-dock-module-factory.h
 	cairo-dock-module-manager.h
+	cairo-dock-module-instance-manager.h
 	cairo-dock-container.h
-	cairo-dock-dock-factory.h			cairo-dock-callbacks.h
+	cairo-dock-dock-factory.h
 	cairo-dock-desklet-factory.h
 	cairo-dock-dialog-factory.h
 	cairo-dock-flying-container.h
@@ -160,13 +161,14 @@
 	cairo-dock-draw.h					cairo-dock-draw-opengl.h
 	cairo-dock-opengl-path.h 			cairo-dock-opengl-font.h 
 	cairo-dock-particle-system.h		cairo-dock-overlay.h
-	cairo-dock-X-utilities.h			cairo-dock-dbus.h
+	cairo-dock-dbus.h
 	cairo-dock-keyfile-utilities.h		cairo-dock-surface-factory.h
 	cairo-dock-log.h					cairo-dock-keybinder.h
 	cairo-dock-application-facility.h	cairo-dock-dock-facility.h
 	cairo-dock-task.h
 	cairo-dock-animations.h
 	cairo-dock-gui-factory.h
+	cairo-dock-utils.h
 	
 	DESTINATION ${includedir}/cairo-dock/gldit)

=== debian/changelog ===
cairo-dock (3.2.99.beta2.1~20130919~bzr1630-0ubuntu1) saucy; urgency=low

  * New upstream snapshot.
  * Detailed Upstream ChangeLog (rev 1613 -> 1629)
    - Dock: Fixed a possible crash when removing an Icon
    - Cinnamon integration: fixed the 'present_class' method
    - Core: a bit of code cleaning
    - ChangeLog: updated the message
    - Icon: launch command: fixed typo
    - Dock visibility: set the input shape fully transparent when the dock
      is hidden
    - Dock visibility: fixed a regression where the dock didn't re-appear
    - cairo-dock.c: connect to SIGHUP to properly quit when its controlling
      terminal is closed
    - po: updated translations
    - X manager: notify of the 'windows stack order changed' when needed
    - Menu: menu-item with buttons inside: connect to the 'draw' event only
      for the given menu-item
    - Class manager: fixed a crash + fixed the auto-stop of the startup
      notification
  * debian/control: bumped plugins version

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Thu, 19 Sep 2013 12:15:44 +0200

=== debian/control ===
--- 
+++ 
@@ -28,9 +28,9 @@
 Architecture: all
 Conflicts: cairo-dock (<= 2.0.8.0)
 Depends: cairo-dock-core (>= ${source:Version}),
-         cairo-dock-plug-ins (>= 3.2.98),
-         cairo-dock-plug-ins-dbus-interface-python (>= 3.2.98),
-         cairo-dock-plug-ins-integration (>= 3.2.98),
+         cairo-dock-plug-ins (>= 3.2.99.beta2.1~20130919~bzr2946),
+         cairo-dock-plug-ins-dbus-interface-python (>= 3.2.99.beta2.1~20130919~bzr2946),
+         cairo-dock-plug-ins-integration (>= 3.2.99.beta2.1~20130919~bzr2946),
          ${misc:Depends}
 Description: Light and eye-candy dock to launch your programs (metapackage)
  Cairo-Dock is a pretty, light and convenient interface to your desktop,
